#include "stdafx.h"
#include "StringUtils.h"

#include <stdarg.h>

#include <boost/algorithm/string.hpp>
#include <boost/lexical_cast.hpp>

using namespace std;

namespace Utils
{

	template <class T> int _replace(std::basic_string<T>& s, const std::basic_string<T>& f, const std::basic_string<T>& t)
	{
		if (!f.size())
			return 0;

		if (t.size() > f.size())
		{
			size_t size = s.size(), dif = t.size() - f.size();
			for (size_t i=s.find(f); i!=std::basic_string<T>::npos; i=s.find(f, i+f.size()), size+=dif);
			s.reserve(size);
		}

		int count = 0;
		for (size_t i=s.find(f); i!=std::basic_string<T>::npos; s.replace(i, f.size(), t), i=s.find(f, i+t.size()), ++count);
		return count;
	}

	int Replace(std::string& s, const std::string& f, const std::string& t)
	{
		return _replace(s, f, t);
	}

	int Replace(std::wstring& s, const std::wstring& f, const std::wstring& t)
	{
		return _replace(s, f, t);
	}

	//////////////////////////////////////////////////////////////////////////
	/*
	bool StringParser::WildcardMatchNoCase(const String &sWildcard, const String &sString)
	{
	String sLowerWild = sWildcard;
	String sLowerStr = sString;

	sLowerWild.ToLower();
	sLowerStr.ToLower();

	const char *wildcard = sLowerWild;
	const char *stringen = sLowerStr;

	return _wildcmp(wildcard, stringen) ? true : false;
	}

	bool StringParser::WildcardMatch(const String &sWildcard, const String &sString)
	{
	const char *wildcard = sWildcard;
	const char *stringen = sString;

	return _wildcmp(wildcard, stringen) ? true : false;
	}

	int StringParser::_wildcmp(const char* wild, const char* string)
	{
	if(*wild == *string)
	return '\0' == *string || _wildcmp(++wild, ++string);

	if('\0' == *string)
	return '*' == *wild && _wildcmp(++wild, string);

	switch(*wild)
	{
	case '?':
	return _wildcmp(++wild, ++string);

	case '*':
	wild++;

	if('\0' == *wild)
	return 1;

	while(*string != '\0')
	if(_wildcmp(wild, string++))
	return 1;

	default:
	return 0;
	}
	}

	*/

	//////////////////////////////////////////////////////////////////////////

	std::string formatstr(const char* str, ...)
	{
		static char b[512];
		va_list args;
		va_start(args, str);

#if _MSC_VER >= 1400 // MSVC++ 8.0 (2005)
		vsnprintf_s(b, sizeof(b), _TRUNCATE, str, args);
#else
		_vsnprintf(b, sizeof(b), str, args);
#endif

		va_end(args);

		return b;
	}

	std::wstring wformatstr(const wchar_t* str, ...)
	{
		static wchar_t b[512];
		va_list args;
		va_start(args, str);

#if _MSC_VER >= 1400 // MSVC++ 8.0 (2005)
		_vsnwprintf_s(b, sizeof(b)/sizeof(wchar_t), _TRUNCATE, str, args);
#else
		_vsnwprintf(b, sizeof(b)/sizeof(wchar_t), str, args);
#endif

		va_end(args);
		return b;
	}

	string wcs2mbs(const wstring& ws)
	{
		string s;

		if (ws.size())
		{
			s.resize(ws.size());
			wcstombs((char*)s.data(), ws.data(), ws.size());
		}

		return s;
	}

	wstring mbs2wcs(const string& s)
	{
		wstring ws;

		if (s.size())
		{
			ws.resize(s.size());
			mbstowcs((wchar_t*)ws.data(), s.data(), s.size());
		}

		return ws;
	}

	int _wildcmp(const char* wild, const char* str)
	{
		if(*wild == *str)
			return '\0' == *str || _wildcmp(++wild, ++str);

		if('\0' == *str)
			return '*' == *wild && _wildcmp(++wild, str);

		switch(*wild)
		{
		case '?':
			return _wildcmp(++wild, ++str);

		case '*':
			wild++;

			if('\0' == *wild)
				return 1;

			while(*str != '\0')
				if(_wildcmp(wild, str++))
					return 1;

		default:
			return 0;
		}
	}



	bool WildcardMatchNoCase(const string &sWildcard, const string &sString)
	{
		string sLowerWild(boost::algorithm::to_lower_copy(sWildcard));
		string sLowerStr (boost::algorithm::to_lower_copy(sString));
		return _wildcmp(sLowerWild.c_str(), sLowerStr.c_str()) ? true : false;
	}
	bool WildcardMatch(const string &sWildcard, const string &sString)
	{
		return _wildcmp(sWildcard.c_str(), sString.c_str()) ? true : false;
	}
	///////////////////////////////////////////////////////////////////////////////////////////////
	//utf8 validator
	/* Ways a UTF stream can screw up */
#define MISSING_CONTINUATION 1 /* a multibyte sequence without as many continuation bytes as expected.  e.g. [ef 81] 48 */
#define UNEXPECTED_CONTINUATION 2 /* A continuation byte when not expected */
#define OVERLONG_FORM 3 /* A full multibyte sequence encoding something that should have been encoded shorter */
#define OUT_OF_RANGE 4 /* A full multibyte sequence encoding something larger than 10FFFF */
#define BAD_SCALAR_VALUE 5 /* A full multibyte sequence encoding something in the range U+D800..U+DFFF */
#define INVALID 6 /* bytes 0xFE or 0xFF */

	typedef unsigned char uint8_t;
	typedef unsigned int uint32_t;
	/* called with: errorCode, bytes_so_far, unichars_so_far, invalid_byte_buf, invalid_byte_buf_len */
	/* NOTE: treat passed byte buffer as a constant, and as something that vanishes after this call returns! */
	typedef void (*error_handler)(int, int, int, uint8_t *, int);

	/* called with: unicode character, bytes_so_far, unichars_so_far, byte_buf, byte_buf_len */
	/* NOTE: treat passed byte buffer as a constant, and as something that vanishes after this call returns! */
	typedef void (*unicode_handler)(uint32_t, int, int, uint8_t *, int);

	typedef struct {
		uint8_t working[6];
		int working_len;
		int unichars_so_far;
		int bytes_so_far;
		int expecting_continuation;
	} utf8_decoder_state_struct;

	typedef utf8_decoder_state_struct *utf8_decoder_state;

	std::string utf8_valid;

	utf8_decoder_state init_utf8_decoder_state(utf8_decoder_state state) {
		utf8_valid.clear();
		state->working_len = 0;
		state->expecting_continuation = 0;
		state->bytes_so_far = 0;
		state->unichars_so_far = 0;
		return state;
	}

	void process_byte(uint8_t incoming, utf8_decoder_state state, unicode_handler unih, error_handler errh) {
		int i, err;
		uint32_t unichar;
		uint8_t *working = state->working;
		if (state->expecting_continuation > 0) {
			if ((incoming & 0xC0) != 0x80) { // not a continuation char
				(*errh)(MISSING_CONTINUATION, state->bytes_so_far, state->unichars_so_far, state->working, state->working_len);
				state->bytes_so_far += state->working_len;
				state->working_len = 0;
				state->expecting_continuation = 0;
				process_byte(incoming, state, unih, errh); // reprocess
				return;
			}
			// else, got a continuation char
			state->working[state->working_len] = incoming;
			state->working_len++;
			state->expecting_continuation--;
			if (state->expecting_continuation == 0) { // finished the unichar
				if (((working[0] & 0xFE) == 0xC0) ||
					((working[0] == 0xE0) && ((working[1] & 0x20) == 0x00)) ||
					((working[0] == 0xF0) && ((working[1] & 0x30) == 0x00)) ||
					((working[0] == 0xF8) && ((working[1] & 0x38) == 0x00)) ||
					((working[0] == 0xFC) && ((working[1] & 0x3C) == 0x00))) {
						(*errh)(OVERLONG_FORM, state->bytes_so_far, state->unichars_so_far, state->working, state->working_len);
						state->bytes_so_far += state->working_len;
						state->working_len = 0;
						state->expecting_continuation = 0;
						return;
				}
				unichar = 0;
				if ((working[0] & 0xE0) == 0xC0) {
					unichar = working[0] & 0x1F;
				} else if ((working[0] & 0xF0) == 0xE0) {
					unichar = working[0] & 0x0F;
				} else if ((working[0] & 0xF8) == 0xF0) {
					unichar = working[0] & 0x07;
				} else {
					unichar = 1; // will be OUT_OF_RANGE
				}
				for(i=1; i < state->working_len; i++) {
					unichar <<= 6;
					unichar += state->working[i] & 0x3F;
				}
				err = 0;
				if (unichar > 0x10FFFF) {
					err = OUT_OF_RANGE;
				} else if ((unichar & 0xF800) == 0xD800) {
					err = BAD_SCALAR_VALUE;
				}
				if (err != 0) {
					(*errh)(err, state->bytes_so_far, state->unichars_so_far, state->working, state->working_len);
					state->bytes_so_far += state->working_len;
					state->working_len = 0;
					state->expecting_continuation = 0;
				} else {
					(*unih)(unichar, state->bytes_so_far, state->unichars_so_far++, state->working, state->working_len);
					state->bytes_so_far += state->working_len;
					state->working_len = 0;
					state->expecting_continuation = 0;
				}
			}
			return;
		} // expecting_continuation

		if ((incoming & 0x80) == 0) { // ASCII
			state->working[0] = incoming;
			unih(incoming, state->bytes_so_far, state->unichars_so_far++, state->working, 1);
			state->bytes_so_far++;
		} else if (((incoming & 0xC0) == 0x80) ||
			((incoming & 0xFE) == 0xFE)) { // continuation but unexpected, or 0xFE-0xFF
				if ((incoming & 0xFE) == 0xFE) {
					err = INVALID;
				} else {
					err = UNEXPECTED_CONTINUATION;
				}
				state->working[0] = incoming;
				(*errh)(err, state->bytes_so_far, state->unichars_so_far, state->working, 1);
				state->bytes_so_far++;
				state->working_len = 0;
				state->expecting_continuation = 0;        
		} else { // start of a multi-byte sequence
			state->working[0] = incoming;
			state->working_len = 1;
			if ((incoming & 0xE0) == 0xC0) { // start of 2-char sequence
				state->expecting_continuation = 1;
			} else if ((incoming & 0xF0) == 0xE0) { // start of 3-char sequence
				state->expecting_continuation = 2;
			} else if ((incoming & 0xF8) == 0xF0) { // start of 4-char sequence
				state->expecting_continuation = 3;
			} else if ((incoming & 0xFC) == 0xF8) { // start of 5-char sequence -- will be OUT_OF_RANGE if complete
				state->expecting_continuation = 4;
			} else if ((incoming & 0xFE) == 0xFC) { // start of 6-char sequence -- will be OUT_OF_RANGE if complete
				state->expecting_continuation = 5;
			}
		}
	}

	void _donothing_unihandler(uint32_t unichar, int bsf, int usf, uint8_t *buf, int buflen) {}
	void end_processing(utf8_decoder_state state, error_handler errh) {
		process_byte(0x0, state, _donothing_unihandler, errh);
	}

	void unichar_handler(uint32_t unichar, int bytes_so_far, int char_index, uint8_t *buf, int buf_len) {
		int i;
		//  printf("%2d Character U+%04X; bytes %d-%d [", char_index, unichar, bytes_so_far, bytes_so_far + buf_len - 1);
		for (i=0; i < buf_len; i++) {
			//if (i > 0) {printf(" ");}
			//printf("%02x", buf[i]);
			utf8_valid+=buf[i];

		}
		// printf("]\n");
	}

	void err_handler(int errcode, int bytes_so_far, int char_index, uint8_t *buf, int buf_len) {
		/*
		int i;
		switch(errcode) {
		case MISSING_CONTINUATION:
		printf("MISSING_CONTINUATION"); break;
		case UNEXPECTED_CONTINUATION:
		printf("UNEXPECTED_CONTINUATION"); break;
		case OVERLONG_FORM:
		printf("OVERLONG_FORM"); break;
		case OUT_OF_RANGE:
		printf("OUT_OF_RANGE"); break;
		case BAD_SCALAR_VALUE:
		printf("BAD_SCALAR_VALUE"); break;
		case INVALID:
		printf("INVALID"); break;
		}
		printf(" at bytes %d-%d [", bytes_so_far, bytes_so_far + buf_len - 1);
		for (i=0; i < buf_len; i++) {
		if (i > 0) {printf(" ");}
		printf("%02x", buf[i]);
		}
		printf("]\n");
		*/
	}
	std::string validateutf8(uint8_t *buf, int buf_len) 
	{
		int i;
		utf8_decoder_state_struct statestorage;
		utf8_decoder_state state = init_utf8_decoder_state(&statestorage);
		for (i=0; i < buf_len; i++) {
			process_byte(buf[i], state, unichar_handler, err_handler);
		}
		end_processing(state, err_handler);
		return utf8_valid;
	}

	///////////////////////////////////////////////////////////////////////////////////////////////
	std::string encodexml(const std::string &_str)
	{
		string str = validateutf8((uint8_t*)_str.c_str(), _str.size());
		std::string res;
		for(size_t i=0;i<str.size();i++){
			switch(str[i])
			{
			case '<': res+="&lt;";break;
			case '>': res+="&gt;";break;
			case '&': res+="&amp;";break;
			case '\'': res+="&apos;";break;
			case '"': res+="&quot;";break;
			case '\x9': 
			case '\xA': 
			case '\xD': 
				res+=str[i];break;
				// 		case '': res+="&ldquo;";break;
				// 		case '': res+="&rdquo;";break;
			default:
				if ((unsigned char)str[i]>=32) {
					res += str[i];
				}
				break;
			}
		}
		return res;
	}
	std::string decodexml(const std::string &str)
	{
		std::string res;
		for(size_t i=0;i<str.size();i++){
			if(str[i]=='&') {
				if(strncmp(str.data() + i, "&lt;", 4)==0){
					res += "<";
					i += 3;
				}else if(strncmp(str.data() + i, "&gt;", 4)==0){
					res += ">";
					i += 3;
				}else if(strncmp(str.data() + i, "&amp;", 5)==0){
					res += "&";
					i += 4;
				}else if(strncmp(str.data() + i, "&apos;", 6)==0){
					res += "\'";
					i += 5;
				}else if(strncmp(str.data() + i, "&quot;", 6)==0){
					res += "\"";
					i += 5;
				}else if(strncmp(str.data() + i, "&ldquo;", 7)==0){
					res += "";
					i += 6;
				}else if(strncmp(str.data() + i, "&rdquo;", 7)==0){
					res += "";
					i += 6;
				}
			}else{
				res+=str[i];
			}
		}
		return res;
	}

	cstringref getValue(mapstring map, cstringref key) {
		static std::string null;
		mapstring::iterator iter = map.find(key);
		if (iter != map.end()) {
			return iter->second;
		}

		return null;
	}

	string FromADGuid(cstringref guid)
	{
		char buf[1024];
		GUID uuid;
		memcpy(&uuid, guid.c_str(), min(sizeof(uuid), guid.size()));
		sprintf(buf, "%08X%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X", uuid.Data1, uuid.Data2, uuid.Data3
			, uuid.Data4[0], uuid.Data4[1], uuid.Data4[2], uuid.Data4[3]
			, uuid.Data4[4], uuid.Data4[5], uuid.Data4[6], uuid.Data4[7]
		);
		return buf;
	}
} // namespace StringUtils

bool xisspace(char ch)
{
	switch(ch)
	{
	case ' ':
	case '\t':
	case '\r':
	case '\n':
		return true;
	default:
		return false;
	}
}
