#ifndef __TYPES_H__
#define __TYPES_H__

#include <tchar.h>
#include <string>
#include <vector>
#include <list>
#include <map>
#include <boost/static_assert.hpp>
#include <boost/filesystem.hpp>

typedef unsigned short	ushort;
typedef unsigned char   uchar;
typedef unsigned int    uint;
typedef unsigned long   ulong;

typedef char  	int8;
typedef short 	int16;
typedef int  	int32;
typedef __int64	int64;

typedef unsigned char		uint8;
typedef unsigned short		uint16;
typedef unsigned int		uint32;
typedef unsigned __int64	uint64;

typedef uint8	byte;
typedef uint16	word;
typedef uint32	dword;
typedef uint64	qword;

typedef uint64 filesize_t;

typedef TCHAR tchar;
typedef const tchar* ctstr;
typedef const wchar_t* cwstr;
typedef const char* cstr;
typedef void* lpvoid;
typedef byte* lpbyte; 

typedef std::vector<std::string> strings;
typedef std::vector<std::wstring> wstrings;
typedef std::list<std::pair<uint32, uint32> > UidRangeList;
typedef std::list<uint32> UidList;
typedef std::map<std::string, std::string> mapstring;
typedef std::pair<std::string, std::string> pairstring;
typedef std::vector<pairstring> lpairstring;

typedef const std::string& cstringref;
typedef std::string& stringref;
typedef const std::string* cstringptr;
typedef const std::wstring& cwstringref;
typedef std::wstring& wstringref;
typedef const std::wstring* cwstringptr;

typedef std::vector<std::string> vstring;
typedef std::vector<std::wstring> vwstring;
typedef std::list<std::string> lstring;
typedef std::list<std::wstring> lwstring;

typedef std::vector<byte> ByteArray;

typedef boost::filesystem::wpath wfilepath;
typedef boost::filesystem::path filepath;
typedef boost::filesystem::wpath* wfilepathptr;
typedef boost::filesystem::path* filepathptr;
typedef const boost::filesystem::wpath& cwfilepathref;
typedef const boost::filesystem::path& cfilepathref;
typedef std::vector<wfilepath> wfilepathlist;

BOOST_STATIC_ASSERT(sizeof(int) != sizeof(__int64) );

#define _def_true
#define _def_false
#define _def_zero
#define _def_minus_1

#endif //__TYPES_H__
