/*

Miranda IM: the free IM client for Microsoft* Windows*

Copyright 2000-2008 Miranda ICQ/IM project, 
all portions of this codebase are copyrighted to the people 
listed in contributors.txt.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once;

#include <windows.h>

DECLARE_HANDLE(HXML);

typedef struct
{
	int cbSize;

	HXML    ( *createNode )( LPCSTR name, LPCSTR text, char bIsDeclaration );
	void    ( *destroyNode )( HXML node );

	HXML    ( *parseString )( LPCSTR string, int* datalen, LPCSTR tag );
	LPSTR  ( *toString )( HXML node, int* datalen );
	LPSTR  ( *toStringF )( HXML node, int* datalen );

	HXML    ( *addChild )( HXML parent, LPCSTR name, LPCSTR text );
	void    ( *addChild2 )( HXML child, HXML parent, int pos );
	HXML    ( *copyNode )( HXML parent);
	HXML    ( *getChild )( HXML parent, int number );
	int     ( *getChildCount )( HXML );
	HXML    ( *getChildByAttrValue )( HXML parent, LPCSTR name, LPCSTR attrName, LPCSTR attrValue );
	HXML    ( *getFirstChild )( HXML parent );
	HXML    ( *getNthChild )( HXML parent, LPCSTR name, int n );
	HXML    ( *getNextChild )( HXML parent, LPCSTR name, int *i );
	HXML    ( *getChildByPath )( HXML parent, LPCSTR path, char createNodeIfMissing );
	HXML    ( *getNextNode )( HXML node );
	LPCSTR ( *getName )( HXML );
	HXML    ( *getParent )( HXML );
	LPCSTR ( *getText )( HXML );
	void    ( *setText )( HXML, LPCSTR );

	LPCSTR ( *getAttr )( HXML, int n );
	LPCSTR ( *getAttrName )( HXML, int n );
	LPCSTR ( *getAttrValue )( HXML, LPCSTR attrName );
	int ( *setAttrValue )( HXML, LPCSTR attrName, LPCSTR value );
	int     ( *getAttrCount )( HXML );
	void    ( *addAttr )( HXML, LPCSTR attrName, LPCSTR attrValue );
	void    ( *addAttrInt )( HXML, LPCSTR attrName, int attrValue );

	void    ( *freeMem )( void* );
}
	XML_API;

/* every protocol should declare this variable to use the XML API */
extern XML_API xi;

/*
a service to obtain the XML API 

wParam = 0;
lParam = (LPARAM)(XML_API*).

returns TRUE if all is Ok, and FALSE otherwise
*/

// #define MS_SYSTEM_GET_XI "Miranda/System/GetXmlApi"
// 
// __forceinline int mir_getXI( XML_API* dest )
// {
// 	dest->cbSize = sizeof(*dest);
// 	return CallService( MS_SYSTEM_GET_XI, 0, (LPARAM)dest );
// }
